$listrow_padding: 12px;
// $listrow_border_radius: 4px;
$listrow_border_radius: 0;
$listrow_item_height: 32px;

// drag mode thing
[draggable] {
}

// List Rows
ul.listrow  {
	margin: 6px 0;
	padding: 0;
	list-style: none;
	width: 100%;
	border: 1px solid $borders_color;
	border-radius:$listrow_border_radius;
	background-color: $base_color;
	// box-shadow:0 2px 4px 0 transparentize($borders_color, 0.6), 0 1px 2px 0 rgba(0,0,0,0.1);


	// list item
	li {
		border:none;
		border-bottom:1px solid darken($base_color, 5%); // draw only bottom
		padding: $listrow_padding;
		height: $listrow_item_height;
		line-height: $listrow_item_height;
		// 100% - padding - border width
		width: calc(100% - (#{$listrow_padding} * 2));

		@extend %noselect;

		* {
			z-index: 15;
		}

		// box-shadow: inset 0 0 0 $listrow_padding red; //debug padding
		// background-color: yellow; //debug 

		&:hover { background-color: darken($base_color, 2%);}
		
		&.edit-mode { background-color:  darken($base_color, 2%);}

		// drag mode
		&.drag-target {
			cursor: move;
			&.dragging {
				opacity: 1;
			}
			&.over {
				// background-color: red; // debug
				border-top: 3px solid $selected_bg_color;
			}
		}

		// text in the list item
		label {

			white-space: nowrap;
			overflow: hidden;
			text-overflow: ellipsis;

			padding: 0 6px;
			&:not(.switch) {
				pointer-events: none;
			}
			&.suggested-action {
				// font-family:$bold_font_family;
				color: $link_color;
			}

			&.destructive-action {
				// font-family:$bold_font_family;
				color: $destructive_color;
			}
		}

		.pillbox {
			display: inline-block;
			background-color:lighten($selected_bg_color, 10%);
			color:$selected_fg_color !important;
			padding: 2px 10px;
			border-radius: 10px;
			margin: 0 12px;
			margin-top: 6px;
			height: 16px;
			line-height: 16px;
			vertical-align: middle;
		}


		&:first-child {
			border-radius: $listrow_border_radius $listrow_border_radius 0 0;
		}

		&.overflow,
		&:last-child {
			border-radius: 0 0 $listrow_border_radius $listrow_border_radius;
			border-bottom:none;
		}

		&:only-child {
			border-radius: $listrow_border_radius;
		}

		// icons in the list item
		.icon {
			vertical-align: top;
			// add margin to equal list item height
			&.s16 {
				padding: 0;
				margin: 8px;
			}
			// same height as list row item
			&.s32 {
				margin: 0;
			}
		}

		// buttons in list item 
		.button {
			// to account for border
			margin-top: -1px;
		}

		// switches in list item 
		.switch {
			// to account for border
			margin-top: -1px;
		}

		// when there are two labels
		.label-group {
			display: inline-block;

			// top label
			:nth-child(1) {
				line-height: 1.5;
				display: block;
			}
			// subtitle
			:nth-child(2) {
				line-height: 1.25;
				display: block;
			}
		}

		// separator
		.separator {
			width: 1px;
			height: $listrow_item_height;
			background-color: lighten($borders_color, 5%);
			display: inline-block;
			padding: 0;
			margin: 0 8px;
			position: relative;
			z-index: 14;
		}

		// spacer
		.spacer {
			margin:0;
			padding:0;
			height: $listrow_item_height;
			max-height: $listrow_item_height;
			display: inline-block;
			width: 6px;
		}

		// drag handle
		.drag-handle {
			opacity: 0.5;
			margin: 0;
			margin-left:-4px !important;
		}
		// expander
		.icon.expander {
			padding: 0;
			margin-left: 0;
			margin-right: 0;
		}
		// link icon
		.icon.link {
			padding: 0 !important;
			margin-left: 2px !important;
			margin-right: 2px !important;
		}

		// input
		input[type=range]{
			vertical-align: middle;
		}

		// small sized list item
		&.small {
			// new height is 40px;
			padding: $listrow_padding - 4px;
			height: $listrow_item_height - 8px;
			line-height: $listrow_item_height - 8px;

			// icons in the list item
			.icon {
				vertical-align: top;
				// add margin to equal list item height
				&.s16 {
					margin: 8px;
					margin-top: 8px + 4px;
				}
				// same height as list row item
				&.s32 {
					margin: 4px;
				}
			}
			>.selection {
				margin: 10px 7px;
			}

			.separator,
			.button,
			.switch {
				// to account for border
				margin-top: -6px;
			}
		}

		// medium sized list item
		&.medium {
			// new height is 40px;
			height: $listrow_item_height + 8px;
			line-height: $listrow_item_height + 8px;

			// icons in the list item
			.icon {
				vertical-align: top;
				// add margin to equal list item height
				&.s16 {
					margin: 8px;
					margin-top: 8px + 4px;
				}
				// same height as list row item
				&.s32 {
					margin: 4px;
				}
			}
			>.selection {
				margin: 10px 7px;
			}

			.separator,
			.button,
			.switch {
				// to account for border
				margin-top: 4px - 1px;
			}
		}

		// large sized list item
		&.large {
			// new height is 40px;
			height: $listrow_item_height * 2;
			line-height: $listrow_item_height * 2;

			// icons in the list item
			.icon {
				vertical-align: middle;
				// add margin to equal list item height
				&.s16 {
					margin: 0;
					// margin-top: 8px + 4px;
				}
				// same height as list row item
				&.s32 {
					margin: 4px;
				}
				&.expander{margin-top: 24px;}
			}
			>.selection {
				margin: 10px 7px;
			}

			.separator,
			.button,
			.switch {
				// to account for border
				margin-top: 16px - 1px;
			}

			input {
				vertical-align: middle;
			}

			.label-group {
				margin-top: 0;
				margin-left: 4px;
				vertical-align: middle;
			}

			label:nth-child(1) {
				padding-bottom: 2px;
			}

			> .link {
				margin-top: 24px !important;
			}
		}
		&.selected {
			background-color:lighten($selected_bg_color, 25%);
			// color:$selected_fg_color;
		}
	}

	a li {
		border-bottom:1px solid darken($base_color, 5%) !important;
		.label-group > label:nth-child(1),
		> label:nth-child(1),
		> label {
			color: $fg_color;
		}
	}

	&.nohover {
		li:hover {background-color:transparent !important;}
	}

	&.borderless {
		border-top:none;
		border-left:none;
		border-right:none;
		border-bottom-color: $borders_color;
		margin: 0;
		box-shadow:none;
	}

	&.unstyled {
		background: transparent;
		border:none;
		margin: 0;
		box-shadow:none;
		> li {
			border:none;
			background:none;
			padding: $listrow_padding 0;
			label,
			> span {
				padding: 0;
				margin: 0;
			}
			// 100% - padding - border width
			width: calc(100% - 2px);
		}
	}
}

// in collapses
.collapsing > ul,
.collapse > ul,
.collapse.in > ul {
	// padding-left: 24px;
	// width: calc(100% - 24px);
	border-bottom-color: lighten($borders_color, 5%);


	> li {
		// height: $listrow_item_height - 8px;
		// line-height: $listrow_item_height - 8px;
		> .button {margin-top:-5px;}
		> .selection {
			margin: 4px;
		}
		&:hover {
		}
		&.selected {
		}
	}
}

// in popovers
.popover-content > ul {
	width: 100%;
	list-style: none;
	margin:0;
	padding:0;
	display: block;
	position: relative;

	> li {
		@extend %noselect;
		width: calc(100% - 8px);
		height: $listrow_item_height;
		line-height: $listrow_item_height;
		padding: 0 4px;
		margin: 0 auto;
		border-radius: 4px;
		border-bottom: none;
		&:hover {
			background-color:lighten($popover_bg_color, 20%);
		}
		&.selected {
		}
	}
}

.window.mobile {
	// List Rows
	ul.listrow  {
		border-radius:4px;
	}
}